import 'package:blox/constants/constants.dart';
import 'package:json_annotation/json_annotation.dart';

part 'text_block_attr.g.dart';

/// TextBlock Attributes (styles) model.
@JsonSerializable()
class TextBlockAttr {
  @JsonKey(
      name: 'font_family',
      defaultValue: Constants.DEFAULT_FONT_FAMILY,
      required: false)
  String fontFamily;
  @JsonKey(
      name: 'font_size',
      defaultValue: Constants.DEFAULT_FONT_SIZE,
      required: false)
  double fontSize;
  @JsonKey(defaultValue: false, required: false)
  bool multiline;
//  @JsonKey(name: 'font_weight')
//  final TextBlockFontWeight fontWeight;

  TextBlockAttr(this.fontFamily, this.fontSize, this.multiline);

  factory TextBlockAttr.fromJson(Map<String, dynamic> json) =>
      _$TextBlockAttrFromJson(json);

  Map<String, dynamic> toJson() => _$TextBlockAttrToJson(this);
}

//enum TextBlockFontWeight {
//  @JsonValue(100)
//  W100,
//  @JsonValue(200)
//  W200,
//}
