import 'package:blox/constants/package_config.dart';
import 'package:blox/constants/supporting_fonts.dart';
import 'package:blox/models/block_document.dart';
import 'package:blox/models/image_block.dart';
import 'package:blox/models/text_block.dart';
import 'package:blox/widgets/image.dart';
import 'package:blox/widgets/text.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class BloxView extends StatefulWidget {
  final BloxDocument bloxDocument;

  final String persianFont;
  final String englishFont;

  const BloxView(
      {Key key,
      @required this.bloxDocument,
      this.persianFont,
      this.englishFont})
      : super(key: key);

  @override
  _BloxViewState createState() => _BloxViewState();
}

class _BloxViewState extends State<BloxView> {
  List<Widget> _list;

  @override
  void initState() {
    super.initState();
    setState(() {
      _list = widget.bloxDocument.blocks.map((e) {
        if (e is TextBlock) {
          return BloxTextView(
            text: e.text,
            style: TextStyle(
              fontFamily: getFont(e.text,
                  persianFont: widget.persianFont,
                  englishFont: widget.englishFont),
              package: PackageConfig.PACKAGE_NAME,
              fontSize: e.style.fontSize
            ),
            multiLine: e.style.multiline,
            );
        }
        if (e is ImageBlock) {
          return BloxImageView(
            imageUrl: e.imageUrl,
          );
        }

        /// Add More Blocks Here
        return null;
      }).toList();
    });
  }

  @override
  Widget build(BuildContext context) {
    return ListView(
      physics: BouncingScrollPhysics(),
      children: _list,
    );
  }
}
